import CodebaseHQConnector from "./CodebaseHQConnector";
import ProjectCollection from "./Project/ProjectCollection";
import UserCollection from "./User/UserCollection";
import Project from "./Project/Project";
import Period from "./TimeSession/Period/Period";
export declare class CodebaseHQAccount extends CodebaseHQConnector {
    private projectCollection;
    private userCollection;
    constructor(apiUser: string, apiKey: string, apiHostname: string);
    /**
     * Returns a collection of all projects
     * @return Project\Collection
     */
    projects(): Promise<ProjectCollection>;
    /**
     * Returns a collection of all projects
     * @param string $permalink
     * @return Project\Project
     */
    project(permalink: string): Promise<Project>;
    /**
     * Returns a collection of all users
     * @return User\Collection
     */
    users(): Promise<UserCollection>;
    /**
     * Populates categories for a project
     * @param Project\Project &$project
     * @return bool
     */
    categories(project: Project): Promise<boolean>;
    /**
     * Populates tickets on the given project
     * @param Project\Project &$project
     * @param int $pageNo
     * @return bool
     */
    tickets(project: Project, pageNo?: number): Promise<boolean>;
    /**
     * Populates time sessions on the given project
     * @param Project\Project &$project
     * @param Period\Period $period
     * @return bool
     */
    times(project: Project, period: Period): Promise<boolean>;
    /**
     * Populates priorities for a project
     * @param Project\Project &$project
     * @return bool
     */
    private priorities;
    /**
     * Populates statuses for a project
     * @param Project\Project &$project
     * @return bool
     */
    private statuses;
    /**
     * Populates types for a project
     * @param Project\Project &$project
     * @return bool
     */
    private types;
}
