"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var CodebaseHQConnector_1 = require("./CodebaseHQConnector");
var ProjectCollection_1 = require("./Project/ProjectCollection");
var UserCollection_1 = require("./User/UserCollection");
var Project_1 = require("./Project/Project");
var Category_1 = require("./Ticket/Category/Category");
var User_1 = require("./User/User");
var Priority_1 = require("./Ticket/Priority/Priority");
var Status_1 = require("./Ticket/Status/Status");
var Type_1 = require("./Ticket/Type/Type");
var _1 = require(".");
var Ticket_1 = require("./Ticket/Ticket");
var forEach = require('p-iteration').forEach;
var CodebaseHQAccount = /** @class */ (function (_super) {
    __extends(CodebaseHQAccount, _super);
    function CodebaseHQAccount(apiUser, apiKey, apiHostname) {
        var _this = _super.call(this, apiUser, apiKey, apiHostname) || this;
        _this.projectCollection = new ProjectCollection_1.default();
        _this.userCollection = new UserCollection_1.default();
        return _this;
    }
    /**
     * Returns a collection of all projects
     * @return Project\Collection
     */
    CodebaseHQAccount.prototype.projects = function () {
        return __awaiter(this, void 0, void 0, function () {
            var projects;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.get('/projects')];
                    case 1:
                        projects = (_a.sent()).projects;
                        if (!projects) return [3 /*break*/, 3];
                        return [4 /*yield*/, forEach(projects.project, function (project) { return __awaiter(_this, void 0, void 0, function () {
                                var ProjectItem;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            ProjectItem = new Project_1.default(project['project-id'], project.name, project.status, project.permalink, project['total-tickets'], project['open-tickets'], project['closed-tickets']);
                                            return [4 /*yield*/, this.categories(ProjectItem)];
                                        case 1:
                                            _a.sent();
                                            return [4 /*yield*/, this.priorities(ProjectItem)];
                                        case 2:
                                            _a.sent();
                                            return [4 /*yield*/, this.statuses(ProjectItem)];
                                        case 3:
                                            _a.sent();
                                            return [4 /*yield*/, this.types(ProjectItem)];
                                        case 4:
                                            _a.sent();
                                            return [4 /*yield*/, this.projectCollection.addProject(ProjectItem)];
                                        case 5:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/, this.projectCollection];
                }
            });
        });
    };
    /**
     * Returns a collection of all projects
     * @param string $permalink
     * @return Project\Project
     */
    CodebaseHQAccount.prototype.project = function (permalink) {
        return __awaiter(this, void 0, void 0, function () {
            var project, projectItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.get("/" + permalink)];
                    case 1:
                        project = (_a.sent()).project;
                        projectItem = new Project_1.default(project['project-id'], project.name, project.status, project.permalink, project['total-tickets'], project['open-tickets'], project['closed-tickets']);
                        return [4 /*yield*/, this.categories(projectItem)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.priorities(projectItem)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.statuses(projectItem)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.types(projectItem)];
                    case 5:
                        _a.sent();
                        return [2 /*return*/, projectItem];
                }
            });
        });
    };
    /**
     * Returns a collection of all users
     * @return User\Collection
     */
    CodebaseHQAccount.prototype.users = function () {
        return __awaiter(this, void 0, void 0, function () {
            var users;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.get('/users')];
                    case 1:
                        users = (_a.sent()).users;
                        if (!users) {
                            return [2 /*return*/, this.userCollection];
                        }
                        return [4 /*yield*/, forEach(users.user, function (user) { return __awaiter(_this, void 0, void 0, function () {
                                var userItem;
                                return __generator(this, function (_a) {
                                    userItem = new User_1.default(user.id, user.enabled ? true : false, user.username ? user.username : null, user.company ? user.company : null, user['email-address'] ? user['email-address'] : null, user['first-name'] ? user['first-name'] : null, user['last-name'] ? user['last-name'] : null, user['gravatar-url'] ? user['gravatar-url'] : null);
                                    this.userCollection.addUser(userItem);
                                    return [2 /*return*/];
                                });
                            }); })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this.userCollection];
                }
            });
        });
    };
    /**
     * Populates categories for a project
     * @param Project\Project &$project
     * @return bool
     */
    CodebaseHQAccount.prototype.categories = function (project) {
        return __awaiter(this, void 0, void 0, function () {
            var url, categories;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "/" + project.getPermalink() + "/tickets/categories";
                        return [4 /*yield*/, this.get(url)];
                    case 1:
                        categories = _a.sent();
                        if (!categories) {
                            return [2 /*return*/, false];
                        }
                        categories = categories['ticketing-categories'];
                        if (!categories['ticketing-category'] || typeof categories['ticketing-category'] !== 'object') {
                            return [2 /*return*/, false];
                        }
                        categories['ticketing-category'].forEach(function (category) {
                            if (!category.id) {
                                return;
                            }
                            var categoryItem = new Category_1.default(category.id, category.name);
                            project.addTicketCategory(categoryItem);
                        });
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * Populates tickets on the given project
     * @param Project\Project &$project
     * @param int $pageNo
     * @return bool
     */
    CodebaseHQAccount.prototype.tickets = function (project, pageNo) {
        if (pageNo === void 0) { pageNo = 1; }
        return __awaiter(this, void 0, void 0, function () {
            var url, tickets;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "/" + project.getPermalink() + "/tickets?page=" + pageNo;
                        return [4 /*yield*/, this.get(url)];
                    case 1:
                        tickets = (_a.sent()).tickets;
                        if (!tickets) {
                            return [2 /*return*/, false];
                        }
                        if (!tickets.ticket) {
                            return [2 /*return*/, false];
                        }
                        return [4 /*yield*/, forEach(tickets.ticket, function (ticket) {
                                if (!ticket['ticket-id'] || typeof ticket !== 'object') {
                                    return;
                                }
                                var assignee = ticket['assignee-id'] ? _this.userCollection.searchById(ticket['assignee-id']) : null;
                                var reporter = ticket['reporter-id'] ? _this.userCollection.searchById(ticket['reporter-id']) : null;
                                var category = project.getTicketCategoryById(ticket['category-id']);
                                var priority = project.getTicketPriorityById(ticket['priority-id']);
                                var status = project.getTicketStatusById(ticket['status-id']);
                                var type = project.getTicketTypeById(ticket['type-id']);
                                var estimatedTime = ticket['estimated-time'] && typeof ticket['estimated-time'] === 'string' ? ticket['estimated-time'] : null;
                                project.addTicket(new Ticket_1.default(ticket['ticket-id'], ticket['project-id'], ticket.summary, new Date(ticket['updated-at']), new Date(ticket['created-at']), ticket['total-time-spent'], reporter, assignee, category, priority, status, type, estimatedTime));
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * Populates time sessions on the given project
     * @param Project\Project &$project
     * @param Period\Period $period
     * @return bool
     */
    CodebaseHQAccount.prototype.times = function (project, period) {
        return __awaiter(this, void 0, void 0, function () {
            var url, timeSessions;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "/" + project.getPermalink() + "/time_sessions" + period.getPeriod();
                        return [4 /*yield*/, this.get(url)];
                    case 1:
                        timeSessions = _a.sent();
                        timeSessions = timeSessions['time-sessions'];
                        if (!timeSessions) {
                            return [2 /*return*/, false];
                        }
                        if (!timeSessions['time-session']) {
                            return [2 /*return*/, false];
                        }
                        timeSessions['time-session'].forEach(function (timeSession) {
                            if (!timeSession.id || typeof timeSession !== 'object') {
                                return;
                            }
                            var user = timeSession['user-id'] ? _this.userCollection.searchById(timeSession['user-id']) : null;
                            var ticket = (!timeSession['ticket-id']) || typeof timeSession['ticket-id'] === 'object' ? null : project.getTickets().searchById(timeSession['ticket-id']);
                            var newTimeSession = new _1.TimeSession(timeSession.id, project, timeSession.summary, timeSession.minutes, new Date(timeSession['session-date']), new Date(timeSession['created-at']), new Date(timeSession['updated-at']), user, ticket);
                            project.addTimeSession(newTimeSession);
                            if (ticket) {
                                ticket.addTimeSession(newTimeSession);
                            }
                            if (user) {
                                user.addTimeSession(newTimeSession);
                            }
                        });
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * Populates priorities for a project
     * @param Project\Project &$project
     * @return bool
     */
    CodebaseHQAccount.prototype.priorities = function (project) {
        return __awaiter(this, void 0, void 0, function () {
            var url, priorities;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "/" + project.getPermalink() + "/tickets/priorities";
                        return [4 /*yield*/, this.get(url)];
                    case 1:
                        priorities = _a.sent();
                        if (!priorities) {
                            return [2 /*return*/, false];
                        }
                        priorities = priorities['ticketing-priorities'];
                        if (!priorities['ticketing-priority'] || typeof priorities['ticketing-priority'] !== 'object') {
                            return [2 /*return*/, false];
                        }
                        priorities['ticketing-priority'].forEach(function (priority) {
                            if (!priority.id) {
                                return;
                            }
                            project.addTicketPriority(new Priority_1.default(priority.id, priority.name ? priority.name : null, priority.colour ? priority.colour : null, priority.default ? priority.default : null, priority.position ? priority.position : null));
                        });
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * Populates statuses for a project
     * @param Project\Project &$project
     * @return bool
     */
    CodebaseHQAccount.prototype.statuses = function (project) {
        return __awaiter(this, void 0, void 0, function () {
            var url, statuses;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "/" + project.getPermalink() + "/tickets/statuses";
                        return [4 /*yield*/, this.get(url)];
                    case 1:
                        statuses = _a.sent();
                        if (!statuses) {
                            return [2 /*return*/, false];
                        }
                        statuses = statuses['ticketing-statuses'];
                        if (!statuses['ticketing-status'] || typeof statuses['ticketing-status'] !== 'object') {
                            return [2 /*return*/, false];
                        }
                        statuses['ticketing-status'].forEach(function (status) {
                            if (typeof status !== 'object' || !status.id) {
                                return;
                            }
                            project.addTicketStatus(new Status_1.default(status.id, status.name ? status.name : null, status.colour ? status.colour : null, status['treat-as-closed'] ? true : null, status.order ? status.order : null));
                        });
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * Populates types for a project
     * @param Project\Project &$project
     * @return bool
     */
    CodebaseHQAccount.prototype.types = function (project) {
        return __awaiter(this, void 0, void 0, function () {
            var url, types;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "/" + project.getPermalink() + "/tickets/types";
                        return [4 /*yield*/, this.get(url)];
                    case 1:
                        types = _a.sent();
                        if (!types) {
                            return [2 /*return*/, false];
                        }
                        types = types['ticketing-types'];
                        if (!types['ticketing-type'] || typeof types['ticketing-type'] !== 'object') {
                            return [2 /*return*/, false];
                        }
                        types['ticketing-type'].forEach(function (type) {
                            if (!type.id || typeof type !== 'object') {
                                return;
                            }
                            project.addTicketType(new Type_1.default(type.id, type.name ? type.name : null));
                        });
                        return [2 /*return*/, true];
                }
            });
        });
    };
    return CodebaseHQAccount;
}(CodebaseHQConnector_1.default));
exports.CodebaseHQAccount = CodebaseHQAccount;
