import TicketCollection from "../Ticket/TicketCollection";
import TimeSessionCollection from "../TimeSession/TimeSessionCollection";
import CategoryCollection from "../Ticket/Category/CategoryCollection";
import PriorityCollection from "../Ticket/Priority/PriorityCollection";
import StatusCollection from "../Ticket/Status/StatusCollection";
import TypeCollection from "../Ticket/Type/TypeCollection";
import Ticket from '../Ticket/Ticket';
import BaseModelInterface from "../BaseModelInterface";
import Category from "../Ticket/Category/Category";
import { TimeSession } from "..";
import Priority from "../Ticket/Priority/Priority";
import Status from "../Ticket/Status/Status";
import Type from "../Ticket/Type/Type";
export default class Project implements BaseModelInterface {
    private id;
    private name;
    private status;
    private permalink;
    private totalTicketCount;
    private openTicketCount;
    private closedTicketCount;
    private ticketCategoryCollection;
    private ticketPriorityCollection;
    private ticketStatusCollection;
    private ticketTypeCollection;
    private ticketCollection;
    private timeSessionCollection;
    constructor(id: number, name: string, status: string, permalink: string, totalTicketCount: number, openTicketCount: number, closedTicketCount: number);
    convertToXml(): any;
    /**
     * Gets project id
     * @return number
     */
    getId(): number;
    /**
     * Gets project name
     * @return string
     */
    getName(): string;
    getStatus(): string;
    getPermalink(): string;
    getTotalTicketCount(): number;
    getOpenTicketCount(): number;
    getClosedTicketCount(): number;
    getTickets(): TicketCollection;
    addTicket(ticket: Ticket): this;
    getTimeSessions(): TimeSessionCollection;
    addTimeSession(timeSession: TimeSession): this;
    getTicketCategories(): CategoryCollection;
    getTicketCategoryById(id: number): any;
    addTicketCategory(ticketCategory: Category): this;
    getTicketPriorities(): PriorityCollection;
    getTicketPriorityById(id: number): any;
    addTicketPriority(ticketPriority: Priority): this;
    getTicketStatuses(): StatusCollection;
    getTicketStatusById(id: number): any;
    addTicketStatus(ticketStatus: Status): void;
    getTicketTypes(): TypeCollection;
    getTicketTypeById(id: number): any;
    addTicketType(ticketType: Type): void;
}
