"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseCollection_1 = require("../BaseCollection");
var ProjectCollection = /** @class */ (function (_super) {
    __extends(ProjectCollection, _super);
    function ProjectCollection() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ProjectCollection.prototype.addProject = function (project) {
        _super.prototype.addItem.call(this, project);
    };
    ProjectCollection.prototype.first = function (callback) {
        if (callback === void 0) { callback = null; }
        return _super.prototype.first.call(this, callback);
    };
    ProjectCollection.prototype.getActive = function () {
        var activeCollection = new ProjectCollection();
        var results = this.all();
        results.forEach(function (project) {
            if (project.getStatus() === 'active') {
                activeCollection.addProject(project);
            }
        });
        return activeCollection;
    };
    ProjectCollection.prototype.searchByName = function (searchTerm, exactMatchOnly) {
        if (exactMatchOnly === void 0) { exactMatchOnly = false; }
        var searchResultCollection = new ProjectCollection();
        var lowerCaseSearchTerm = searchTerm.toLowerCase();
        var results = this.all();
        results.forEach(function (project) {
            var lowerCaseProjectName = project.getName().toLowerCase();
            if ((!exactMatchOnly && lowerCaseProjectName.indexOf(lowerCaseSearchTerm) !== -1) ||
                (exactMatchOnly && lowerCaseProjectName === lowerCaseSearchTerm)) {
                searchResultCollection.addProject(project);
            }
        });
        return searchResultCollection;
    };
    return ProjectCollection;
}(BaseCollection_1.default));
exports.default = ProjectCollection;
