export default class Priority {
    private id;
    private name;
    private colour;
    private default;
    private position;
    /**
     * Constructor
     * @param int $id
     * @param string $name
     * @return void
     */
    constructor(id: number, name?: string | null, colour?: string | null, defaultOption?: boolean | null, position?: number | null);
    /**
     * Gets priority id
     * @return int
     */
    getId(): number;
    /**
     * Gets priority name
     * @return null|string
     */
    getName(): string | null;
    /**
     * Gets priority colour
     * @return null|string
     */
    getColour(): string | null;
    /**
     * Gets priority default
     * @return null|bool
     */
    getDefault(): boolean | null;
    /**
     * Gets priority position
     * @return null|int
     */
    getPosition(): number | null;
}
