"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Priority = /** @class */ (function () {
    /**
     * Constructor
     * @param int $id
     * @param string $name
     * @return void
     */
    function Priority(id, name, colour, defaultOption, position) {
        if (name === void 0) { name = null; }
        if (colour === void 0) { colour = null; }
        if (defaultOption === void 0) { defaultOption = null; }
        if (position === void 0) { position = null; }
        this.id = id;
        this.name = name;
        this.colour = colour;
        this.default = defaultOption;
        this.position = position;
    }
    /**
     * Gets priority id
     * @return int
     */
    Priority.prototype.getId = function () {
        return this.id;
    };
    /**
     * Gets priority name
     * @return null|string
     */
    Priority.prototype.getName = function () {
        return this.name;
    };
    /**
     * Gets priority colour
     * @return null|string
     */
    Priority.prototype.getColour = function () {
        return this.colour;
    };
    /**
     * Gets priority default
     * @return null|bool
     */
    Priority.prototype.getDefault = function () {
        return this.default;
    };
    /**
     * Gets priority position
     * @return null|int
     */
    Priority.prototype.getPosition = function () {
        return this.position;
    };
    return Priority;
}());
exports.default = Priority;
