export default class Status {
    private id;
    private name;
    private colour;
    private treatAsClosed;
    private order;
    constructor(id: number, name?: string | null, colour?: string | null, treatAsClosed?: boolean | null, order?: number | null);
    /**
     * Gets status id
     * @return int
     */
    getId(): number;
    /**
     * Gets status name
     * @return null|string
     */
    getName(): string | null;
    /**
     * Gets status colour
     * @return null|string
     */
    getColour(): string | null;
    /**
     * Returns whether the status is closed or not
     * @return null|bool
     */
    isClosed(): boolean | null;
    /**
     * Gets status order
     * @return null|int
     */
    getOrder(): number | null;
}
