"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Status = /** @class */ (function () {
    function Status(id, name, colour, treatAsClosed, order) {
        if (name === void 0) { name = null; }
        if (colour === void 0) { colour = null; }
        if (treatAsClosed === void 0) { treatAsClosed = null; }
        if (order === void 0) { order = null; }
        this.id = id;
        this.name = name;
        this.colour = colour;
        this.treatAsClosed = treatAsClosed;
        this.order = order;
    }
    /**
     * Gets status id
     * @return int
     */
    Status.prototype.getId = function () {
        return this.id;
    };
    /**
     * Gets status name
     * @return null|string
     */
    Status.prototype.getName = function () {
        return this.name;
    };
    /**
     * Gets status colour
     * @return null|string
     */
    Status.prototype.getColour = function () {
        return this.colour;
    };
    /**
     * Returns whether the status is closed or not
     * @return null|bool
     */
    Status.prototype.isClosed = function () {
        return this.treatAsClosed;
    };
    /**
     * Gets status order
     * @return null|int
     */
    Status.prototype.getOrder = function () {
        return this.order;
    };
    return Status;
}());
exports.default = Status;
