import BaseCollection from "../BaseCollection";
import Ticket from "./Ticket";
export default class TicketCollection extends BaseCollection {
    private STATUS_CLOSED;
    private STATUS_OPEN;
    /**
     * Adds a ticket to the collection
     * @param Ticket $ticket
     * @return void
     */
    addTicket(ticket: Ticket): void;
    /**
     * Returns a new collection of open tickets
     * @return Collection
     */
    getOpen(): TicketCollection;
    /**
     * Returns a new collection of closed tickets
     * @return Collection
     */
    getClosed(): TicketCollection;
    /**
     * Returns a new collection of tickets that are open/closed
     * @param bool $returnClosed
     * @return type
     */
    private getByStatus;
}
