"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseCollection_1 = require("../BaseCollection");
var TicketCollection = /** @class */ (function (_super) {
    __extends(TicketCollection, _super);
    function TicketCollection() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.STATUS_CLOSED = true;
        _this.STATUS_OPEN = false;
        return _this;
    }
    /**
     * Adds a ticket to the collection
     * @param Ticket $ticket
     * @return void
     */
    TicketCollection.prototype.addTicket = function (ticket) {
        this.addItem(ticket);
    };
    /**
     * Returns a new collection of open tickets
     * @return Collection
     */
    TicketCollection.prototype.getOpen = function () {
        return this.getByStatus(this.STATUS_OPEN);
    };
    /**
     * Returns a new collection of closed tickets
     * @return Collection
     */
    TicketCollection.prototype.getClosed = function () {
        return this.getByStatus(this.STATUS_CLOSED);
    };
    /**
     * Returns a new collection of tickets that are open/closed
     * @param bool $returnClosed
     * @return type
     */
    TicketCollection.prototype.getByStatus = function (returnClosed) {
        var collection = new TicketCollection();
        var allTickets = this.all();
        allTickets.forEach(function (ticket) {
            var status = ticket.getStatus();
            if (status && status.isClosed() === returnClosed) {
                collection.addTicket(ticket);
            }
        });
        return collection;
    };
    return TicketCollection;
}(BaseCollection_1.default));
exports.default = TicketCollection;
