import Project from "../Project/Project";
import Ticket from "../Ticket/Ticket";
import User from "../User/User";
import BaseModelInterface from "../BaseModelInterface";
export default class TimeSession implements BaseModelInterface {
    private id;
    private project;
    private summary;
    private minutes;
    private sessionDate;
    private user;
    private ticket;
    private updatedAt;
    private createdAt;
    /**
     * Constructor
     * @param int $id
     * @param Project\Project $project
     * @param string $summary
     * @param int $minutes
     * @param \DateTime $sessionDate
     * @param User\User $user
     * @param null|Ticket\Ticket $ticket
     * @param \DateTime $updatedAt
     * @param \DateTime $createdAt
     * @return void
     */
    constructor(id: number, project: Project, summary: string, minutes: number, sessionDate: Date, updatedAt: Date, createdAt: Date, user?: User | null, ticket?: Ticket | null);
    convertToXml(): any;
    /**
     * Gets Time Session id
     * @return int
     */
    getId(): number;
    /**
     * Gets Time Session Project
     * @return Project\Project
     */
    getProject(): Project;
    /**
     * Gets Time Session summary
     * @return string
     */
    getSummary(): string;
    /**
     * Gets Time Session minutes
     * @return int
     */
    getMinutes(): number;
    /**
     * Gets Time Session date
     * @return \DateTime
     */
    getSessionDate(): Date;
    /**
     * Gets Time Session User
     * @return null|User\User
     */
    getUser(): User | null;
    /**
     * Gets Time Session Ticket
     * @return null|Ticket\Ticket
     */
    getTicket(): Ticket | null;
    /**
     * Gets Time Session updated date
     * @return \DateTime
     */
    getUpdatedAt(): Date;
    /**
     * Gets Time Session created date
     * @return \DateTime
     */
    getCreatedAt(): Date;
}
