import User from "./User";
import BaseCollection from "../BaseCollection";
export default class UserCollection extends BaseCollection {
    /**
     * Adds a user to the collection
     * @param User $user
     * @return void
     */
    addUser(user: User): void;
    /**
     * Returns a new collection of active users
     * @return Collection
     */
    getActive(): UserCollection;
    /**
     * Searches for users by company name
     * @param string searchTerm
     * @return Collection
     */
    searchByCompany(searchTerm: string, exactMatchOnly?: boolean): UserCollection;
    /**
     * Searches for users by username
     * @param string searchTerm
     * @return Collection
     */
    searchByUsername(searchTerm: string, exactMatchOnly?: boolean): UserCollection;
}
