"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseCollection_1 = require("../BaseCollection");
var UserCollection = /** @class */ (function (_super) {
    __extends(UserCollection, _super);
    function UserCollection() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Adds a user to the collection
     * @param User $user
     * @return void
     */
    UserCollection.prototype.addUser = function (user) {
        _super.prototype.addItem.call(this, user);
    };
    /**
     * Returns a new collection of active users
     * @return Collection
     */
    UserCollection.prototype.getActive = function () {
        var activeCollection = new UserCollection();
        var users = this.all();
        users.forEach(function (user) {
            if (user.getEnabled()) {
                activeCollection.addUser(user);
            }
        });
        return activeCollection;
    };
    /**
     * Searches for users by company name
     * @param string searchTerm
     * @return Collection
     */
    UserCollection.prototype.searchByCompany = function (searchTerm, exactMatchOnly) {
        if (exactMatchOnly === void 0) { exactMatchOnly = false; }
        var searchResultCollection = new UserCollection();
        var lowerCaseSearchTerm = searchTerm.toLowerCase();
        var results = this.all();
        results.forEach(function (user) {
            var lowerCaseCompany = user.getCompany().toLowerCase();
            if ((!exactMatchOnly && lowerCaseCompany.indexOf(lowerCaseSearchTerm) !== -1) ||
                (exactMatchOnly && lowerCaseCompany === lowerCaseSearchTerm)) {
                searchResultCollection.addUser(user);
            }
        });
        return searchResultCollection;
    };
    /**
     * Searches for users by username
     * @param string searchTerm
     * @return Collection
     */
    UserCollection.prototype.searchByUsername = function (searchTerm, exactMatchOnly) {
        if (exactMatchOnly === void 0) { exactMatchOnly = false; }
        var searchResultCollection = new UserCollection();
        var lowerCaseSearchTerm = searchTerm.toLowerCase();
        var results = this.all();
        results.forEach(function (user) {
            var lowerCaseUsername = user.getUsername().toLowerCase();
            if ((!exactMatchOnly && lowerCaseUsername.indexOf(lowerCaseSearchTerm) !== -1) ||
                (exactMatchOnly && lowerCaseUsername === lowerCaseSearchTerm)) {
                searchResultCollection.addUser(user);
            }
        });
        return searchResultCollection;
    };
    return UserCollection;
}(BaseCollection_1.default));
exports.default = UserCollection;
